#if !defined(_SEModule_h_inc_)
#define _SEModule_h_inc_

#include "SEModule_base.h"

class Module : public SEModule_base
{
public:
	Module(seaudioMasterCallback2 seaudioMaster, void *p_resvd1);
	~Module();

	static bool getModuleProperties (SEModuleProperties* properties);
	virtual bool getPinProperties (long index, SEPinProperties* properties);
	void SE_CALLING_CONVENTION sub_process(long buffer_offset, long sampleFrames );
	void SE_CALLING_CONVENTION sub_process_static(long buffer_offset, long sampleFrames );
	void OnPlugStateChange(SEPin *pin);
	virtual void open();

private:
	int static_count;
	float samplerate;

	float *input_in;
	float *dtime_in;
	float *fback_in;
	float *cutoff_in;
	float *resonance_in;
	float *wetmix_in;
	float *overdrive_in;
	short d_type;
	short d_mode;
	short time_mode;
	float *audio_out_l;
	float *audio_out_r;

	float time_divisions[20];

	float pan_position, prev_pan_position;

	// Delay Variables
	float delaytime;
	FSAMPLE * buffer;
	int buffersize;
	int count, count2;
	float this_sample;
	int delay_direction, pan_direction;

	// Filter Variables
	float a0,a1,a2;
	float b1,b2;
	float t0,t1,t2;
	float c0,c1;
	float xold1,xold2;
	float yold1,yold2;
	float y;


};
#endif
